<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CustomerIDElement1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CustomerIDElement1 extends AbstractStructArrayBase
{
    /**
     * The ReferredClient
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CustomerIDElement[]
     */
    public $ReferredClient;
    /**
     * Constructor method for ArrayOfJP_CustomerIDElement1
     * @uses ArrayOfJP_CustomerIDElement1::setReferredClient()
     * @param \StructType\JP_CustomerIDElement[] $referredClient
     */
    public function __construct(array $referredClient = array())
    {
        $this
            ->setReferredClient($referredClient);
    }
    /**
     * Get ReferredClient value
     * @return \StructType\JP_CustomerIDElement[]|null
     */
    public function getReferredClient()
    {
        return $this->ReferredClient;
    }
    /**
     * This method is responsible for validating the values passed to the setReferredClient method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReferredClient method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReferredClientForArrayConstraintsFromSetReferredClient(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CustomerIDElement1ReferredClientItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CustomerIDElement1ReferredClientItem instanceof \StructType\JP_CustomerIDElement) {
                $invalidValues[] = is_object($arrayOfJP_CustomerIDElement1ReferredClientItem) ? get_class($arrayOfJP_CustomerIDElement1ReferredClientItem) : sprintf('%s(%s)', gettype($arrayOfJP_CustomerIDElement1ReferredClientItem), var_export($arrayOfJP_CustomerIDElement1ReferredClientItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReferredClient property can only contain items of type \StructType\JP_CustomerIDElement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReferredClient value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CustomerIDElement[] $referredClient
     * @return \ArrayType\ArrayOfJP_CustomerIDElement1
     */
    public function setReferredClient(array $referredClient = array())
    {
        // validation for constraint: array
        if ('' !== ($referredClientArrayErrorMessage = self::validateReferredClientForArrayConstraintsFromSetReferredClient($referredClient))) {
            throw new \InvalidArgumentException($referredClientArrayErrorMessage, __LINE__);
        }
        $this->ReferredClient = $referredClient;
        return $this;
    }
    /**
     * Add item to ReferredClient value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CustomerIDElement $item
     * @return \ArrayType\ArrayOfJP_CustomerIDElement1
     */
    public function addToReferredClient(\StructType\JP_CustomerIDElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CustomerIDElement) {
            throw new \InvalidArgumentException(sprintf('The ReferredClient property can only contain items of type \StructType\JP_CustomerIDElement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReferredClient[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CustomerIDElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CustomerIDElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CustomerIDElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CustomerIDElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CustomerIDElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReferredClient
     */
    public function getAttributeName()
    {
        return 'ReferredClient';
    }
}
